op_baseWrite <-
function(dsn, input, ident = NULL, name = NULL, unit = NULL, objtype_id = NULL, who = NULL, acttype = NULL, sort = TRUE) {
#Open database connection
db <- odbcConnect(dsn)

#Coerce input into a data frame if it isn't one already; get rid of empty cells
if (is.array(input)) dataframe <- as.data.frame(as.table(input)) else dataframe <- input
rescol <- colnames(dataframe) == "Freq"
if (length(rescol[rescol==TRUE]) >= 1) rescol <- "Freq" else {
rescol <- colnames(dataframe) == "Result"
if (length(rescol[rescol==TRUE]) >= 1) rescol <- "Result" else {
rescol <- colnames(dataframe) == "result"
if (length(rescol[rescol==TRUE]) >= 1) rescol <- "result"
}
}
dataframe <- dataframe[is.na(dataframe[,rescol]) == FALSE,]

#Add page to database (if it doesn't already exist)
if (is.null(ident)==TRUE) if (interactive()) ident <- readline(paste("What is the identifier of this object?", 
"\n", sep = "")) else stop("indentifier of object no given")
if (length(grep("Op_en", ident))==1) {wiki_id <- 1; page <- substring(ident, 6, nchar(ident))} else {
if (length(grep("Op_fi", ident))==1) {wiki_id <- 2; page <- substring(ident, 6, nchar(ident))} else {
if (length(grep("Erac", ident))==1) {wiki_id <- 6; page <- substring(ident, 5, nchar(ident))} else {
wiki_id <- 0; page <- 0; warning("No wiki id found in ident, writing zero.")}}}
obj_id <- sqlQuery(db, paste('SELECT id FROM obj WHERE ident = "', ident, '"', sep = ''))[1,1]
if (is.na(obj_id)==TRUE) {
if (is.null(name)==TRUE) if (interactive()) name <- readline(paste("What is the name of this object?", 
"\n", sep = "")) else stop("object name not given")
if (is.null(objtype_id)==TRUE) if (interactive()) objtype_id <- readline(paste("What type of object is", 
" this (id)?", paste(paste(sqlQuery(db, "SELECT id FROM objtype")[,1], sqlQuery(db, paste("SELECT objtype",
" FROM objtype", sep = ""))[,1], sep = " - "), collapse = ", "), "\n", collapse = " ")) else {
stop("object type not given")}
sqlQuery(db, paste('INSERT INTO obj (ident, name, objtype_id, page, wiki_id) VALUES ("', paste(ident, 
name, sep = '","'), '",', paste(objtype_id, page, wiki_id, sep = ','), ')', sep = ''))
obj_id <- sqlQuery(db, paste('SELECT id FROM obj WHERE ident = "', ident, '"', sep = ''))[1,1]
}

#Write act and actobj
if (is.null(who)==TRUE) if (interactive()) {who <- readline(paste("What is the name of the uploader?", "\n", sep = "")) 
} else stop("uploader name not given")
series_id <- sqlQuery(db, paste("SELECT series_id FROM actobj WHERE obj_id = ", obj_id, " ORDER BY series_id DESC LIMIT 1", 
sep = ""))[1,1]
if (is.na(series_id)==FALSE) {if (is.null(acttype)==TRUE) {if (interactive()) {acttype <- readline(paste("What type of upload", 
" is this? 4 - new data to replace any existing, 5 - new data to be appended to existing data (must have the same", 
" indices).", "\n", sep = "")) 
} else acttype <- 4 
}} else acttype <- 4
if (acttype != 4 & acttype != 5) stop ("proper acttype not given")
sqlQuery(db, paste('INSERT INTO act (acttype_id, who, comments) VALUES (', acttype, ',"', who, '","R upload")', sep = ''))
act_id <- sqlQuery(db, "SELECT id FROM act ORDER BY id DESC LIMIT 1")[1,1]
if (acttype == 4) series_id <- act_id
if (is.null(unit)==TRUE) if (interactive()) unit <- readline(paste("What is the unit of this object?", 
"\n", sep = "")) else stop("unit not given")
sqlQuery(db, paste('INSERT INTO actobj (act_id, obj_id, series_id, unit) VALUES (', paste(act_id, obj_id, series_id, sep = ','), 
',"', unit, '")', sep = ''))
actobj_id <- sqlQuery(db, paste('SELECT id FROM actobj WHERE act_id = ', act_id, sep = ''))[1,1]

#Write indexes
ColNames <- colnames(dataframe[(colnames(dataframe) == "id") == FALSE])
ColNames <- ColNames[(ColNames == "obs") == FALSE]
ColNames <- ColNames[(ColNames == "Result") == FALSE]
ColNames <- ColNames[(ColNames == "result") == FALSE]
ColNames <- ColNames[(ColNames == "Freq") == FALSE]
nind <- length(ColNames)
DimNames <- rep(vector("list", 1), nind)
names(DimNames) <- ColNames
indlengths <- 0
for (i in 1:nind) {
DimNames[[i]] <- levels(factor(dataframe[, ColNames[i]]))
indlengths[i] <- length(DimNames[[i]])
}
for (i in 1:length(ColNames)) {
sqlQuery(db, paste('INSERT IGNORE INTO obj (ident, name, objtype_id) VALUES ("', gsub(' ', '_', ColNames[i]), '","', 
ColNames[i], '", 6)', sep = ''))
}
IndIds <- sqlQuery(db, paste('SELECT id, ident FROM obj WHERE ident IN("', paste(gsub(" ", "_", ColNames), 
collapse = '","'), '")', sep = ''))
DimIds <- DimNames
DimN <- 1:nind
names(DimN) <- tolower(gsub(" ", "_", ColNames))
for (i in 1:nrow(IndIds)) {
names(DimIds)[DimN[tolower(IndIds[i,2])]] <- IndIds[i, 1]
}

#Write locations
y <- 1
LocNames <- as.data.frame(matrix(rep(NA, 2*sum(indlengths)), sum(indlengths), 2))
for (i in 1:nind) {
LocNames[y:(y + indlengths[i] - 1),1:2] <- matrix(c(rep(names(DimIds)[i], indlengths[i]), 
DimNames[[i]]), indlengths[i], 2)
y <- y + indlengths[i]
}
for (i in 1:nrow(LocNames)) {
sqlQuery(db, paste('INSERT IGNORE INTO loc (obj_id_i, location) VALUES (', LocNames[i,1], ',"', LocNames[i,2], '")', 
sep = ''))
}
LocIds <- data.frame(matrix(NA, nrow(LocNames), 3))
temp <- NA
for (i in 1:nind) {
temp <- sqlQuery(db, paste('SELECT id, obj_id_i, location FROM loc WHERE location IN("', paste(LocNames[(sum(
indlengths[1:i]) - indlengths[i] + 1):sum(indlengths[1:i]), 2], collapse = '","'), '") AND obj_id_i IN(', 
paste(names(DimIds)[i], collapse = ','), ')', sep = ''))
LocIds[(sum(indlengths[1:i]) - indlengths[i] + 1):sum(indlengths[1:i]),1:2] <- temp[,1:2]
LocIds[(sum(indlengths[1:i]) - indlengths[i] + 1):sum(indlengths[1:i]),3] <- gsub(" +", "", as.character(temp[,3]))
}
LocMap <- NA
y <- 1
for (i in 1:nind) {
LocMap <- LocIds[LocIds[,2]==names(DimIds)[i], 1]
names(LocMap) <- tolower(LocIds[LocIds[,2]==names(DimIds)[i], 3])
DimIds[[i]] <- LocMap[gsub(" +", "", tolower(DimNames[[i]]))]
}

#Writing actloc
sqlQuery(db, paste("INSERT INTO actloc (actobj_id, loc_id) VALUES (", paste(actobj_id, LocIds[,1], sep = ",", 
collapse = "),("), ")", sep = ""))

#Changing location names in table into ids
for (i in 1:nind) {
dataframe[,ColNames[i]] <- factor(dataframe[,ColNames[i]])
levels(dataframe[,ColNames[i]]) <- DimIds[[i]]
}

#A hidden parameter for adjusting query packet sizes, the higher the faster, though crash becomes likelier
maxrows <- 50000

#Writing cell
obscol <- colnames(dataframe) == "obs"
if (length(obscol[obscol==TRUE]) >= 1) {
obscol <- TRUE
n <- length(levels(factor(dataframe[,"obs"])))} else {
obscol <- FALSE
n <- 1
}
if (obscol) if (sort) {
dataframe <- dataframe[order(dataframe[,"obs"]),]
for (i in 1:nind) {
dataframe <- dataframe[order(dataframe[,ColNames[i]]),]
}
}
ncell <- nrow(dataframe)/n
cellQuery <- NA
cellQuery[1:ncell*8-7] <- actobj_id
cellQuery[1:ncell*8-6] <- ","
if (n == 1) {
cellQuery[1:ncell*8-5] <- dataframe[,rescol]
 cellQuery[1:ncell*8-3] <- 0} else {
cellQuery[1:ncell*8-5] <- apply(matrix(dataframe[,rescol], n, ncell), 2, mean)
cellQuery[1:ncell*8-3] <- sd(matrix(dataframe[,rescol], n, ncell))
}
cellQuery[1:ncell*8-4] <- ","
cellQuery[1:ncell*8-2] <- ","
cellQuery[1:ncell*8-1] <- n
cellQuery[1:ncell*8] <- "),("
cellQuery[ncell*8] <- ""
if (ncell >= maxrows) {
for (i in 1:(ncell%/%maxrows)) {
sqlQuery(db, paste('INSERT INTO cell (actobj_id, mean, sd, n) VALUES (', paste(cellQuery[
((i-1)*8*maxrows+1):(i*8*maxrows-1)], collapse = ''), ')', sep = ''))
}
}
if (ncell%%maxrows != 0) sqlQuery(db, paste('INSERT INTO cell (actobj_id, mean, sd, n) VALUES (', paste(cellQuery[(ncell%/%
maxrows*8*maxrows+1):length(cellQuery)], collapse = ''), ')', sep = ''))

#Writing res
cell_id <- sqlQuery(db, paste("SELECT id FROM cell WHERE actobj_id = ", actobj_id, " ORDER BY ID", sep = ""))[,1]
if (ncell != length(cell_id)) stop("Number of cells written does not match with expected value")
resQuery <- NA
resQuery[1:nrow(dataframe)*6-5] <- rep(cell_id, each = n)
resQuery[1:nrow(dataframe)*6-4] <- ","
if (n==1) resQuery[1:nrow(dataframe)*6-3] <- "0" else resQuery[1:nrow(dataframe)*6-3] <- as.character(dataframe[,"obs"])
resQuery[1:nrow(dataframe)*6-2] <- ","
resQuery[1:nrow(dataframe)*6-1] <- dataframe[,rescol]
resQuery[1:nrow(dataframe)*6] <- "),("
resQuery[nrow(dataframe)*6] <- ""
if (nrow(dataframe) >= maxrows) {
for (i in 1:(nrow(dataframe)%/%maxrows)) {
sqlQuery(db, paste('INSERT INTO res (cell_id, obs, result) VALUES (', paste(resQuery[((i-1)
*6*maxrows+1):(i*6*maxrows-1)], collapse = ''), ')', sep = ''))
}
}
if (nrow(dataframe)%%maxrows != 0) sqlQuery(db, paste('INSERT INTO res (cell_id, obs, result) VALUES (', paste(resQuery[
(nrow(dataframe)%/%maxrows*6*maxrows+1):length(resQuery)], collapse = ''), ')', sep = ''))

#Writing loccell
locidmatrix <- rep(NA, nind*ncell)
dim(locidmatrix) <- c(nind,ncell)
for (i in 1:nind) {
locidmatrix[i,] <- as.character(dataframe[1:ncell*n - n + 1,ColNames[i]])
}
loccellQuery <- rep(NA, 4*nind*ncell)
dim(loccellQuery) <- c(4*nind, ncell)
loccellQuery[1:nind*4-3, 1:ncell] <- rep(cell_id, each = nind)
loccellQuery[1:nind*4-2, 1:ncell] <- ","
loccellQuery[1:nind*4-1, 1:ncell] <- locidmatrix
loccellQuery[1:nind*4, 1:ncell] <- "),("
loccellQuery[nind*4, ncell] <- ""
if (ncell*nind >= maxrows) {
for (i in 1:(ncell%/%(maxrows%/%nind))) {
loccellQuery[nind*4, i*(maxrows%/%nind)] <- ""
sqlQuery(db, paste('INSERT INTO loccell (cell_id, loc_id) VALUES (', paste(loccellQuery[,
((i-1)*(maxrows%/%nind)+1):(i*(maxrows%/%nind))], collapse = ''), ')', sep = ''))
}
}
if ((ncell*nind)%%maxrows != 0) sqlQuery(db, paste('INSERT INTO loccell (cell_id, loc_id) VALUES (', paste(loccellQuery[,
(ncell%/%(maxrows%/%nind)*(maxrows%/%nind)+1):ncell], collapse = ''), ')', sep = ''))

#Close database connection
odbcClose(db)
return(0)
}

